/*
 * Linux-specific defines for treno
 * Contributed by Holger Trapp
 */

/* UDP header fields */
#define uh_sport source
#define uh_dport dest
#define uh_sum check
#define uh_ulen len

/* redefine struct icmphdr as struct icmp */
struct icmp {
  __u8      type;
  __u8      code;
  __u16     checksum;
  union {
    struct {
        __u16   id;
        __u16   sequence;
    } echo;
    __u32   gateway;
  } un; 
};

/* ICMP message fields */
#define icmp_type type
#define icmp_seq un.echo.sequence
#define icmp_id un.echo.id
#define icmp_cksum checksum
#define icmp_code code
#define icmp_void un.gateway

/* ICMP message types and codes */
#define ICMP_TIMXCEED ICMP_TIME_EXCEEDED
#define ICMP_UNREACH  ICMP_DEST_UNREACH
#define ICMP_UNREACH_NEEDFRAG ICMP_FRAG_NEEDED
#define ICMP_MASKREPLY ICMP_ADDRESSREPLY
#define ICMP_SOURCEQUENCH ICMP_SOURCE_QUENCH
#define ICMP_PARAMPROB ICMP_PARAMETERPROB
#define ICMP_TSTAMP ICMP_TIMESTAMP
#define ICMP_TSTAMPREPLY ICMP_TIMESTAMPREPLY
#define ICMP_IREQ ICMP_INFO_REQUEST
#define ICMP_IREQREPLY ICMP_INFO_REPLY
#define ICMP_MASKREQ ICMP_ADDRESS

/* minimum length of an ICMP message */
#define ICMP_MINLEN 8

/* Definitions present in later versions of linux */
#ifndef IP_DF
#define IP_DF		0x4000		/* Flag: "Don't Fragment"	*/
#endif

#define BYTESWAP_IP_DF	1		/* raw socket fixup */
